<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::thread_pool_implementation Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1thread__pool__implementation.html">thread_pool_implementation</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-types">Private Types</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classdlib_1_1thread__pool__implementation-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::thread_pool_implementation Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::thread_pool_implementation:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1thread__pool__implementation.png" usemap="#dlib::thread_5Fpool_5Fimplementation_map" alt=""/>
  <map id="dlib::thread_5Fpool_5Fimplementation_map" name="dlib::thread_5Fpool_5Fimplementation_map">
<area href="classdlib_1_1multithreaded__object.html" alt="dlib::multithreaded_object" shape="rect" coords="0,0,194,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1thread__pool__implementation_1_1function__object__copy.html">function_object_copy</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1thread__pool__implementation_1_1function__object__copy__instance.html">function_object_copy_instance</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1thread__pool__implementation_1_1task__state__type.html">task_state_type</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a726dae6586ea222b1bd312c7f4b16241"><td class="memItemLeft" align="right" valign="top"><a id="a726dae6586ea222b1bd312c7f4b16241"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>wait_for_task</b> (<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a> task_id) const</td></tr>
<tr class="separator:a726dae6586ea222b1bd312c7f4b16241"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9cef0e2fcf84f8a72a6adb8bab3b9e2"><td class="memItemLeft" align="right" valign="top"><a id="aa9cef0e2fcf84f8a72a6adb8bab3b9e2"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>num_threads_in_pool</b> () const</td></tr>
<tr class="separator:aa9cef0e2fcf84f8a72a6adb8bab3b9e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4fc7d0d279420fd848c49a22139e3a4"><td class="memItemLeft" align="right" valign="top"><a id="ab4fc7d0d279420fd848c49a22139e3a4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>wait_for_all_tasks</b> () const</td></tr>
<tr class="separator:ab4fc7d0d279420fd848c49a22139e3a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac787b4f9937539f38249a2011f4f02b2"><td class="memItemLeft" align="right" valign="top"><a id="ac787b4f9937539f38249a2011f4f02b2"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_task_thread</b> () const</td></tr>
<tr class="separator:ac787b4f9937539f38249a2011f4f02b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6bbb3c8ab8c1c599ea28414e2c2cae8f"><td class="memTemplParams" colspan="2"><a id="a6bbb3c8ab8c1c599ea28414e2c2cae8f"></a>
template&lt;typename T &gt; </td></tr>
<tr class="memitem:a6bbb3c8ab8c1c599ea28414e2c2cae8f"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><b>add_task</b> (T &amp;obj, void(T::*funct)())</td></tr>
<tr class="separator:a6bbb3c8ab8c1c599ea28414e2c2cae8f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7fd673e4cdebef9a78f25f44e9ea012"><td class="memTemplParams" colspan="2"><a id="ab7fd673e4cdebef9a78f25f44e9ea012"></a>
template&lt;typename T &gt; </td></tr>
<tr class="memitem:ab7fd673e4cdebef9a78f25f44e9ea012"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><b>add_task</b> (T &amp;obj, void(T::*funct)(long), long arg1)</td></tr>
<tr class="separator:ab7fd673e4cdebef9a78f25f44e9ea012"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb29f21ec254f1aa3a749e58e5dec535"><td class="memTemplParams" colspan="2"><a id="abb29f21ec254f1aa3a749e58e5dec535"></a>
template&lt;typename T &gt; </td></tr>
<tr class="memitem:abb29f21ec254f1aa3a749e58e5dec535"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><b>add_task</b> (T &amp;obj, void(T::*funct)(long, long), long arg1, long arg2)</td></tr>
<tr class="separator:abb29f21ec254f1aa3a749e58e5dec535"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9abe527ed170787bcbb2634658465458"><td class="memItemLeft" align="right" valign="top"><a id="a9abe527ed170787bcbb2634658465458"></a>
<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memItemRight" valign="bottom"><b>add_task_internal</b> (const <a class="el" href="classdlib_1_1thread__pool__implementation.html#a78dc30565151c99bf3fb898f82b7a3c8">bfp_type</a> &amp;bfp, <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a>&lt; <a class="el" href="structdlib_1_1thread__pool__implementation_1_1function__object__copy.html">function_object_copy</a> &gt; &amp;item)</td></tr>
<tr class="separator:a9abe527ed170787bcbb2634658465458"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adae285952e6561955f2c0197d89c2fbd"><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#adae285952e6561955f2c0197d89c2fbd">add_task_internal</a> (const <a class="el" href="classdlib_1_1thread__pool__implementation.html#a78dc30565151c99bf3fb898f82b7a3c8">bfp_type</a> &amp;bfp)</td></tr>
<tr class="separator:adae285952e6561955f2c0197d89c2fbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a431eefa611dbe938111cda6ebf9f7d25"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a431eefa611dbe938111cda6ebf9f7d25">shutdown_pool</a> ()</td></tr>
<tr class="separator:a431eefa611dbe938111cda6ebf9f7d25"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-types"></a>
Private Types</h2></td></tr>
<tr class="memitem:a78dc30565151c99bf3fb898f82b7a3c8"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1bound__function__pointer.html">bound_function_pointer::kernel_1a_c</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a78dc30565151c99bf3fb898f82b7a3c8">bfp_type</a></td></tr>
<tr class="separator:a78dc30565151c99bf3fb898f82b7a3c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a94aba191ef159ba851d55d9c300c9d62"><td class="memItemLeft" align="right" valign="top"><a id="a94aba191ef159ba851d55d9c300c9d62"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>thread_pool_implementation</b> (unsigned long num_threads)</td></tr>
<tr class="separator:a94aba191ef159ba851d55d9c300c9d62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83332796eee930e051ac89c7c36d027f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a83332796eee930e051ac89c7c36d027f">is_worker_thread</a> (const thread_id_type id) const</td></tr>
<tr class="separator:a83332796eee930e051ac89c7c36d027f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a92981f3055e0c064d8033c3b08a23f2f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a92981f3055e0c064d8033c3b08a23f2f">thread</a> ()</td></tr>
<tr class="separator:a92981f3055e0c064d8033c3b08a23f2f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07778bc2499d1a58bdf52fdcf85684b7"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a07778bc2499d1a58bdf52fdcf85684b7">find_empty_task_slot</a> () const</td></tr>
<tr class="separator:a07778bc2499d1a58bdf52fdcf85684b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83ebd467a38c8172b0f7ab78c1511656"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a83ebd467a38c8172b0f7ab78c1511656">find_ready_task</a> () const</td></tr>
<tr class="separator:a83ebd467a38c8172b0f7ab78c1511656"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a81153e8c78c99c256a94990174becc1c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a81153e8c78c99c256a94990174becc1c">make_next_task_id</a> (long idx)</td></tr>
<tr class="separator:a81153e8c78c99c256a94990174becc1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a331ed7561e6d5b0e44f4757ae3834dee"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1thread__pool__implementation.html#a331ed7561e6d5b0e44f4757ae3834dee">task_id_to_index</a> (<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a> id) const</td></tr>
<tr class="separator:a331ed7561e6d5b0e44f4757ae3834dee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb206923d630d5f1046de17db9fe7efd"><td class="memItemLeft" align="right" valign="top"><a id="aeb206923d630d5f1046de17db9fe7efd"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>thread_pool_implementation</b> (<a class="el" href="classdlib_1_1thread__pool__implementation.html">thread_pool_implementation</a> &amp;)</td></tr>
<tr class="separator:aeb206923d630d5f1046de17db9fe7efd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a802b4d90050344220fdffed644a93835"><td class="memItemLeft" align="right" valign="top"><a id="a802b4d90050344220fdffed644a93835"></a>
<a class="el" href="classdlib_1_1thread__pool__implementation.html">thread_pool_implementation</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1thread__pool__implementation.html">thread_pool_implementation</a> &amp;)</td></tr>
<tr class="separator:a802b4d90050344220fdffed644a93835"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classdlib_1_1multithreaded__object"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classdlib_1_1multithreaded__object')"><img src="closed.png" alt="-"/>&#160;Private Member Functions inherited from <a class="el" href="classdlib_1_1multithreaded__object.html">dlib::multithreaded_object</a></td></tr>
<tr class="memitem:a132da50fb1eedda870ca50e2367f493f inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1multithreaded__object.html#a132da50fb1eedda870ca50e2367f493f">multithreaded_object</a> ()</td></tr>
<tr class="separator:a132da50fb1eedda870ca50e2367f493f inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a58103fff8cefe4e054f95a6e32f05625 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="a58103fff8cefe4e054f95a6e32f05625"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a58103fff8cefe4e054f95a6e32f05625 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2bef919330ecc2fa4b7823ce1fb1a32b inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="a2bef919330ecc2fa4b7823ce1fb1a32b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_running</b> () const</td></tr>
<tr class="separator:a2bef919330ecc2fa4b7823ce1fb1a32b inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a329de49834eeb7dd160d6412aca32e73 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="a329de49834eeb7dd160d6412aca32e73"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>number_of_threads_alive</b> () const</td></tr>
<tr class="separator:a329de49834eeb7dd160d6412aca32e73 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acc20d5ef936246880e74ef98ae4f9123 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="acc20d5ef936246880e74ef98ae4f9123"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>number_of_threads_registered</b> () const</td></tr>
<tr class="separator:acc20d5ef936246880e74ef98ae4f9123 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6118653ea9248c13bc33e5dd854c749c inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="a6118653ea9248c13bc33e5dd854c749c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>wait</b> () const</td></tr>
<tr class="separator:a6118653ea9248c13bc33e5dd854c749c inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad165a3f13254d0c313f6f194d5831ee1 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="ad165a3f13254d0c313f6f194d5831ee1"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>start</b> ()</td></tr>
<tr class="separator:ad165a3f13254d0c313f6f194d5831ee1 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a501f4a0a543be0bebf39ca539c91b912 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="a501f4a0a543be0bebf39ca539c91b912"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>pause</b> ()</td></tr>
<tr class="separator:a501f4a0a543be0bebf39ca539c91b912 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa50393c917c1c79224de71abfba7237a inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="aa50393c917c1c79224de71abfba7237a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>stop</b> ()</td></tr>
<tr class="separator:aa50393c917c1c79224de71abfba7237a inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9235b464122f57fe4c4882c15ae4cd63 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memItemLeft" align="right" valign="top"><a id="a9235b464122f57fe4c4882c15ae4cd63"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>should_stop</b> () const</td></tr>
<tr class="separator:a9235b464122f57fe4c4882c15ae4cd63 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d2f02da858f0ec12e5286c6f08c62f2 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memTemplParams" colspan="2"><a id="a0d2f02da858f0ec12e5286c6f08c62f2"></a>
template&lt;typename T &gt; </td></tr>
<tr class="memitem:a0d2f02da858f0ec12e5286c6f08c62f2 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><b>register_thread</b> (T &amp;object, void(T::*thread)())</td></tr>
<tr class="separator:a0d2f02da858f0ec12e5286c6f08c62f2 inherit pub_methods_classdlib_1_1multithreaded__object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:abd3c6a62190d911133a07a10ed69dc75"><td class="memItemLeft" align="right" valign="top"><a id="abd3c6a62190d911133a07a10ed69dc75"></a>
<a class="el" href="classdlib_1_1array.html">array</a>&lt; <a class="el" href="structdlib_1_1thread__pool__implementation_1_1task__state__type.html">task_state_type</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>tasks</b></td></tr>
<tr class="separator:abd3c6a62190d911133a07a10ed69dc75"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d14af263f333cba7d5dc7e083756e67"><td class="memItemLeft" align="right" valign="top"><a id="a1d14af263f333cba7d5dc7e083756e67"></a>
<a class="el" href="classdlib_1_1array.html">array</a>&lt; thread_id_type &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>worker_thread_ids</b></td></tr>
<tr class="separator:a1d14af263f333cba7d5dc7e083756e67"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9ee3c2eee740b13e54d675abd4d0c0d"><td class="memItemLeft" align="right" valign="top"><a id="ad9ee3c2eee740b13e54d675abd4d0c0d"></a>
<a class="el" href="classdlib_1_1mutex.html">mutex</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m</b></td></tr>
<tr class="separator:ad9ee3c2eee740b13e54d675abd4d0c0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8753ff011e6202e0296b996fa33e56a"><td class="memItemLeft" align="right" valign="top"><a id="ab8753ff011e6202e0296b996fa33e56a"></a>
<a class="el" href="classdlib_1_1signaler.html">signaler</a>&#160;</td><td class="memItemRight" valign="bottom"><b>task_done_signaler</b></td></tr>
<tr class="separator:ab8753ff011e6202e0296b996fa33e56a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19fbf967111a01d20de88f709d4edfd6"><td class="memItemLeft" align="right" valign="top"><a id="a19fbf967111a01d20de88f709d4edfd6"></a>
<a class="el" href="classdlib_1_1signaler.html">signaler</a>&#160;</td><td class="memItemRight" valign="bottom"><b>task_ready_signaler</b></td></tr>
<tr class="separator:a19fbf967111a01d20de88f709d4edfd6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf0ead382c483b12a2db441e165950ef"><td class="memItemLeft" align="right" valign="top"><a id="adf0ead382c483b12a2db441e165950ef"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>we_are_destructing</b></td></tr>
<tr class="separator:adf0ead382c483b12a2db441e165950ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a63d668995109028bdc9cdbb726de4807"><td class="memItemLeft" align="right" valign="top"><a id="a63d668995109028bdc9cdbb726de4807"></a>
class&#160;</td><td class="memItemRight" valign="bottom"><b>thread_pool</b></td></tr>
<tr class="separator:a63d668995109028bdc9cdbb726de4807"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a78dc30565151c99bf3fb898f82b7a3c8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a78dc30565151c99bf3fb898f82b7a3c8">&#9670;&nbsp;</a></span>bfp_type</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classdlib_1_1bound__function__pointer.html">bound_function_pointer::kernel_1a_c</a> <a class="el" href="classdlib_1_1thread__pool__implementation.html#a78dc30565151c99bf3fb898f82b7a3c8">dlib::thread_pool_implementation::bfp_type</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">CONVENTION
    - num_threads_in_pool() == tasks.size()
    - if (the destructor has been called) then
        - we_are_destructing == true
    - else
        - we_are_destructing == false

    - is_task_thread() == is_worker_thread(get_thread_id())

    - m == the mutex used to protect everything in this object
    - worker_thread_ids == an array that contains the thread ids for
      all the threads in the thread pool
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="adae285952e6561955f2c0197d89c2fbd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adae285952e6561955f2c0197d89c2fbd">&#9670;&nbsp;</a></span>add_task_internal()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a> dlib::thread_pool_implementation::add_task_internal </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classdlib_1_1thread__pool__implementation.html#a78dc30565151c99bf3fb898f82b7a3c8">bfp_type</a> &amp;&#160;</td>
          <td class="paramname"><em>bfp</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - adds a task to call the given bfp object.
    - swaps item into the internal task object which will have a lifetime
      at least as long as the running task.
    - returns the task id for this new task
</pre><p> ! </p>

</div>
</div>
<a id="a07778bc2499d1a58bdf52fdcf85684b7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07778bc2499d1a58bdf52fdcf85684b7">&#9670;&nbsp;</a></span>find_empty_task_slot()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">long dlib::thread_pool_implementation::find_empty_task_slot </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">this is the function that executes the threads in the thread pool
</pre><p> ! </p>

</div>
</div>
<a id="a83ebd467a38c8172b0f7ab78c1511656"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83ebd467a38c8172b0f7ab78c1511656">&#9670;&nbsp;</a></span>find_ready_task()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">long dlib::thread_pool_implementation::find_ready_task </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - m is locked
ensures
    - if (there is currently a empty task slot) then
        - returns the index of that task slot in tasks
        - there is a task slot
    - else
        - returns -1
</pre><p> ! </p>

</div>
</div>
<a id="a83332796eee930e051ac89c7c36d027f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83332796eee930e051ac89c7c36d027f">&#9670;&nbsp;</a></span>is_worker_thread()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool dlib::thread_pool_implementation::is_worker_thread </td>
          <td>(</td>
          <td class="paramtype">const thread_id_type&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - causes all threads to terminate and blocks the
      caller until this happens.
</pre><p> ! </p>

</div>
</div>
<a id="a81153e8c78c99c256a94990174becc1c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a81153e8c78c99c256a94990174becc1c">&#9670;&nbsp;</a></span>make_next_task_id()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a> dlib::thread_pool_implementation::make_next_task_id </td>
          <td>(</td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>idx</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - m is locked
ensures
    - if (there is currently a task to do) then
        - returns the index of that task in tasks
    - else
        - returns -1
</pre><p> ! </p>

</div>
</div>
<a id="a431eefa611dbe938111cda6ebf9f7d25"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a431eefa611dbe938111cda6ebf9f7d25">&#9670;&nbsp;</a></span>shutdown_pool()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dlib::thread_pool_implementation::shutdown_pool </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - adds a task to call the given bfp object.
    - returns the task id for this new task
</pre><p> ! </p>

</div>
</div>
<a id="a331ed7561e6d5b0e44f4757ae3834dee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a331ed7561e6d5b0e44f4757ae3834dee">&#9670;&nbsp;</a></span>task_id_to_index()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long dlib::thread_pool_implementation::task_id_to_index </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - m is locked
    - 0 &lt;= idx &lt; tasks.size()
ensures
    - returns the next index to be used for tasks that are placed in
      tasks[idx]
</pre><p> ! </p>

</div>
</div>
<a id="a92981f3055e0c064d8033c3b08a23f2f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a92981f3055e0c064d8033c3b08a23f2f">&#9670;&nbsp;</a></span>thread()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void dlib::thread_pool_implementation::thread </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - m is locked
ensures
    - if (thread with given id is one of the thread pool's worker threads or num_threads_in_pool() == 0) then
        - returns true
    - else
        - returns false
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="thread__pool__extension_8h_source.html">thread_pool_extension.h</a></li>
<li>thread_pool_extension.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
